# filesystem.set_zfs_attributes

Set special ZFS-related file flags on the specified path

readonly - this maps to READONLY MS-DOS attribute. When set, file may not be written to (toggling does not impact existing file opens).

hidden - this maps to HIDDEN MS-DOS attribute. When set, the SMB HIDDEN flag is set and file is “hidden” from the perspective of SMB clients.

system - this maps to SYSTEM MS-DOS attribute. Is presented to SMB clients, but has no impact on local filesystem.

archive - this maps to ARCHIVE MS-DOS attribute. Value is reset to True whenever file is modified.

immutable - file may not be altered or deleted. Also appears as IMMUTABLE in attributes in filesystem.stat output and as STATX_ATTR_IMMUTABLE in statx() response.

nounlink - file may be altered but not deleted.

appendonly - file may only be opened with O_APPEND flag. Also appears as APPEND in attributes in filesystem.stat output and as STATX_ATTR_APPEND in statx() response.

offline - this maps to OFFLINE MS-DOS attribute. Is presented to SMB clients, but has no impact on local filesystem.

sparse - maps to SPARSE MS-DOS attribute. Is presented to SMB clients, but has no impact on local filesystem.

Type: object

##

Type: array
No Additional Items

#### Tuple Validation

##### Parameter 1: set_zfs_file_attributes

#### set_zfs_file_attributes

Type: object

FilesystemSetZfsAttributesArgs parameters.

No Additional Properties

##

#### Path

Type: string

Path to the file to set ZFS attributes on.

Must be at least `1` characters long

##

#### ZFSFileAttrsData

Type: object

ZFS file attributes to set.

No Additional Properties

##

#### Readonly

Default: null

READONLY MS-DOS attribute. When set, file may not be written to (toggling does not impact existing file opens).

## Any of

Type: boolean
Type: null

##

#### Hidden

Default: null

HIDDEN MS-DOS attribute. When set, the SMB HIDDEN flag is set and file is "hidden" from the perspective of SMB clients.

## Any of

Type: boolean
Type: null

##

#### System

Default: null

SYSTEM MS-DOS attribute. Is presented to SMB clients, but has no impact on local filesystem.

## Any of

Type: boolean
Type: null

##

#### Archive

Default: null

ARCHIVE MS-DOS attribute. Value is reset to True whenever file is modified.

## Any of

Type: boolean
Type: null

##

#### Immutable

Default: null

File may not be altered or deleted. Also appears as IMMUTABLE in attributes in `filesystem.stat` output and as STATXATTRIMMUTABLE in statx() response.

## Any of

Type: boolean
Type: null

##

#### Nounlink

Default: null

File may be altered but not deleted.

## Any of

Type: boolean
Type: null

##

#### Appendonly

Default: null

File may only be opened with OAPPEND flag. Also appears as APPEND in attributes in `filesystem.stat` output and as STATXATTR_APPEND in statx() response.

## Any of

Type: boolean
Type: null

##

#### Offline

Default: null

OFFLINE MS-DOS attribute. Is presented to SMB clients, but has no impact on local filesystem.

## Any of

Type: boolean
Type: null

##

#### Sparse

Default: null

SPARSE MS-DOS attribute. Is presented to SMB clients, but has no impact on local filesystem.

## Any of

Type: boolean
Type: null

##

#### ZFSFileAttrsData

Type: object

The updated ZFS file attributes.

No Additional Properties

##

#### Readonly

Default: null

READONLY MS-DOS attribute. When set, file may not be written to (toggling does not impact existing file opens).

## Any of

Type: boolean
Type: null

##

#### Hidden

Default: null

HIDDEN MS-DOS attribute. When set, the SMB HIDDEN flag is set and file is "hidden" from the perspective of SMB clients.

## Any of

Type: boolean
Type: null

##

#### System

Default: null

SYSTEM MS-DOS attribute. Is presented to SMB clients, but has no impact on local filesystem.

## Any of

Type: boolean
Type: null

##

#### Archive

Default: null

ARCHIVE MS-DOS attribute. Value is reset to True whenever file is modified.

## Any of

Type: boolean
Type: null

##

#### Immutable

Default: null

File may not be altered or deleted. Also appears as IMMUTABLE in attributes in `filesystem.stat` output and as STATXATTRIMMUTABLE in statx() response.

## Any of

Type: boolean
Type: null

##

#### Nounlink

Default: null

File may be altered but not deleted.

## Any of

Type: boolean
Type: null

##

#### Appendonly

Default: null

File may only be opened with OAPPEND flag. Also appears as APPEND in attributes in `filesystem.stat` output and as STATXATTR_APPEND in statx() response.

## Any of

Type: boolean
Type: null

##

#### Offline

Default: null

OFFLINE MS-DOS attribute. Is presented to SMB clients, but has no impact on local filesystem.

## Any of

Type: boolean
Type: null

##

#### Sparse

Default: null

SPARSE MS-DOS attribute. Is presented to SMB clients, but has no impact on local filesystem.

## Any of

Type: boolean
Type: null

Required roles: FILESYSTEM_ATTRS_WRITE